Home page logo
/

oss-sec logo oss-sec mailing list archives

Re: CVE Request: kernel - sock_diag: Fix out-of-bounds access to sock_diag_handlers[]
From: Solar Designer <solar () openwall com>
Date: Mon, 25 Feb 2013 14:13:49 +0400

On Sun, Feb 24, 2013 at 10:10:45AM +0100, Mathias Krause wrote:
An unprivileged user can send a netlink message resulting in an
out-of-bounds access of the sock_diag_handlers[] array which, in turn,
allows userland to take over control while in kernel mode.

Patch (already in net/master):
http://thread.gmane.org/gmane.linux.network/260061

Affected versions:
v3.3 - v3.8

Nice find!  Do you happen to know of distro backports of the affected
code to older kernels?  When you wrote that the bug is "in there for
ages", did you mean that 3.3 has been out "for ages" or something else?

PoC is not attached this time but can be requested on demand. Hint:
Works well on Fedora 18, bypassing all mmap_min_addr checks. ;)

SynQ posted a (different?) PoC here:

https://rdot.org/forum/showthread.php?p=30828

Apparently, high values of mmap_min_addr (like 131072) happen to work
against this one, but they might not work against other attack vectors
or/and kernel builds.  The bug is not a NULL+offset dereference, so
mmap_min_addr was not supposed to help against its exploitation - it
just happens to, sometimes.

Alexander


  By Date           By Thread  

Current thread:
[ Nmap | Sec Tools | Mailing Lists | Site News | About/Contact | Advertising | Privacy ]
AlienVault